type PixelValue = string | number | boolean | null | undefined;

type PixelNestedObject = Record<string, PixelValue | Array<PixelValue>>;

type PixelParameters = Record<string, PixelValue | Array<PixelValue> | PixelNestedObject>;

interface FacebookPixelEvents {
  (method: 'track', eventName: string, parameters?: PixelParameters): void;
  track: (eventName: string, parameters?: PixelParameters) => void;
}

declare global {
  interface Window {
    fbq: FacebookPixelEvents;
  }
}

export const trackEvent = (eventName: string, parameters?: PixelParameters) => {
  if (typeof window !== 'undefined' && window.fbq) {
    window.fbq('track', eventName, parameters);
  }
};
